const axios = require("axios");

const HOST = "http://localhost/txmomo";
const URL_CRON_GET_HISTORY = HOST + "/cron/get-history.php";

const API_SESSION = HOST + "/api/v1/session/";

const TIME_SCHEDULE = 500;
const TIME_BETTWEEN_TASK = 2000;

const SCHEDULES = [
    {
        url: HOST+"/cron/reward.php",
        step: 1,
        time: 5000
    },
    // {
    //     url: "http://localhost/2/{id}",
    //     step: 10,
    //     time: 60000
    // },
];

let oneReq = { session: -1, history: false};
(
    function cron() {
        axios({
            url: API_SESSION
        }).then(({ data }) => {
            let code = data.code;
            let message = data.message;
            let time_remaining = -1, session = -1, result = "...";
            if (data.data != null) {
                time_remaining = data.data.time_remaining;
                session = data.data.session;
                if (data.data.result != null)
                    result = data.data.result;
            }
            if (oneReq.session != session) {
                oneReq.session = session;
                oneReq.history = false;
            }
            if (code == 0 && session != -1 && oneReq.history == false) {
                oneReq.history = true;
                axios({
                    url: URL_CRON_GET_HISTORY
                }).then().catch(error => null);
                console.log(`[Phiên #${session}] lấy lịch sử giao dịch.`);
            }
            log(`[Phiên #${session}][${time_remaining}s còn lại][Kết quả: ${result}] -> ${message}`);
        }).catch((error) => {
            if (error.response != null) {
                response = error.response;
                log(`[${response.status} ${response.statusText}] Request failure!`);
            }
        }).then(() => {
            setTimeout(cron, TIME_SCHEDULE);
        });
    }

)();

SCHEDULES.forEach((v) => {
    executeTask(v);
});

function executeTask(task = { url: "", step: 10, time: 30000 }) {
    let total = 0;
    for (let i = 0; i < task.step; i++) {
        let sleep = between(TIME_BETTWEEN_TASK * i, 500);
        setTimeout(() => {
            let url = task.url.replace(/\{id\}/g, i);
            log(`excuteTask [${sleep}ms] ${url} ...`);
            axios({
                url: url
            }).then(resp => null).catch(error => null);
        }, sleep);
    }
    setTimeout(() => executeTask(task), task.time);
}


function between(num, num_block) {
    return randomInteger(num - num_block, num + num_block);
}

function randomInteger(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
}

function log(t) {
    console.log(t);
}